---
title: XRFrame.getViewerPose()
slug: Web/API/XRFrame/getViewerPose
tags:
  - API
  - AR
  - Augmented Reality
  - Method
  - Reference
  - VR
  - Virtual Reality
  - WebXR
  - WebXR Device API
  - XR
  - XRFrame
  - getViewerPose
  - pose
---
<div>{{draft}}{{securecontext_header}}{{APIRef("WebXR Device API")}}</div>

<p class="summary"><span class="seoSummary">The <code><strong>getViewerPose()</strong></code> method, a member of the {{domxref("XRFrame")}} interface, returns a {{domxref("XRViewerPose")}} object which describes the viewer's pose (position and orientation) relative to the specified reference space.</span></p>

<p>See the {{domxref("XRFrame.getPose", "getPose()")}} method for a way to calculate a pose that represents the difference between two spaces.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox">var <var>xrViewerPose</var> = <em>xrFrame</em>.getViewerPose(<em>referenceSpace</em>);</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt><code>referenceSpace</code></dt>
 <dd>An {{domxref("XRReferenceSpace")}} object specifying the space to use as the reference point or base for the computation of the viewer's current pose.</dd>
</dl>

<h3 id="Return_value">Return value</h3>

<p>A {{domxref("XRViewerPose")}} describing the viewer's position and orientation relative to the specified reference space.</p>

<h3 id="Exceptions">Exceptions</h3>

<dl>
 <dt><code>InvalidStateError</code></dt>
 <dd>A {{domxref('DOMException')}} indicating that <code>getViewerPose()</code> was not called within the context of a callback to a session's {{domxref("XRSession.requestAnimationFrame", "XRSession.requestAnimationFrame()")}}.</dd>
</dl>

<h2 id="Examples">Examples</h2>

<p>In this callback function for {{domxref("XRSession.requestAnimationFrame", "requestAnimationFrame()")}}, the {{domxref("XRViewerPose")}} describing the viewer's viewpoint on the world is obtained by calling <code>getViewerPose()</code> on the {{domxref("XRFrame")}} passed into the callback.</p>

<pre class="brush: js">viewerPose = xrFrame.getViewerPose(xrReferenceSpace);

if (viewerPose) {
  /* render the pose's views */
}
</pre>

<p>To see a complete example, take a look at <a href="/en-US/docs/Web/API/WebXR_Device_API/Movement_and_motion">Movement, orientation, and motion</a>.</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('WebXR','#dom-xrframe-getviewerpose','XRFrame.getViewerPose()')}}</td>
   <td>{{Spec2('WebXR')}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.XRFrame.getViewerPose")}}</p>
